<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"] = (@$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"] ?: array()) + array("_c336a736" . "f98472e69" . "eb00017dd" . "a5a17e" => base64_decode("dHJpZ2dlcl9" . "lcnJvcg=="), "_1d5727e95902d6c" . "a0a94581ac86acf2" . "6" => base64_decode("QXR0ZW1wdCB0byBsb2FkIGF0dGVuZGVlcyBsaXN0IHdpdGg" . "gbm8gbGlzdF9pZA=="), "_cce0d01909" . "1a193c2ea09" . "8ab902d8821" => base64_decode("QXR0ZW1wdCB0byBzYXZlIG" . "F0dGVuZGVlcyB3aXRoIG5v" . "IGxpc3RfaWQh"), "_4d2b763f00ba1e8" . "001879ba79a84926" . "9" => base64_decode("YXJyYXlfaW50ZXJzZ" . "WN0X2tleQ=="), "_a8391504b805b5d572e9b1a5c5d" . "0169e" => base64_decode("Tm8gbGlzdCBpZA" . "=="), "_31767d7ad58e706dbf47b7a51a0fe6" . "c4" => base64_decode("Y291bnQ" . "="), "_f5e940c614f55e" . "70f210df8306ffb" . "d17" => base64_decode("YXJyYXlfZmlsbF9rZ" . "Xlz"), "_c06c961f393742ecfd52" . "b72263ac9470" => base64_decode("aW50dm" . "Fs"), "_39b6f979f725d2d0669" . "51011e1554c14" => base64_decode("YXJyYXlfZGlmZl9r" . "ZXk="));
abstract class CalendarEventParticipants extends ErrorHandler
{
    protected $is_list_loaded;
    protected $list_id = false;
    protected $users = array();
    protected $deleted_users = array();
    protected $new_users = array();
    protected $old_users = array();
    
    
    
    
    protected $event;
    public function __construct(CalendarObject $event)
    {
        $this->event = $event;
        $this->is_list_loaded = false;
    }
    
    
    
    
    
    
    public function SetUsers($_c9cc2169cfc80b4728d6b39dfdcba6bb)
    {
        
        
        $_c9cc2169cfc80b4728d6b39dfdcba6bb = $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_f5e940c614f55e70f2" . "10df8306ffbd17"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, 1);
        
        
        $this->deleted_users = $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_39b6f979f725d2d066951011e1554c" . "14"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->new_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_39b6f979f725d2d" . "066951011e1554c1" . "4"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, $this->users);
        $this->old_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_4d2b763f00ba1e8001879ba79a849" . "269"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->is_list_loaded = true;
    }
    public function Load()
    {
        if (!$this->list_id) {
            throw new Exception($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_1d5727e" . "95902d6c" . "a0a94581" . "ac86acf2" . "6"]);
        }
        $this->deleted_users = array();
        $this->new_users = array();
        $this->old_users = array();
        $this->is_list_loaded = true;
    }
    public function SetListId($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        $this->list_id = $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_c06c961f393742ecfd52b72" . "263ac9470"]($_0ea4e32b57963ac0cb3057e03e9aef64);
        if ($_0ea4e32b57963ac0cb3057e03e9aef64 === null) {
            $this->is_list_loaded = true;
        }
    }
    
    
    
    
    
    
    public function isAttendeesChanged()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_31767d7ad58e706dbf47b" . "7a51a0fe6c4"]($this->new_users) > 0 || $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_31767d7ad58e706dbf" . "47b7a51a0fe6c4"]($this->deleted_users) > 0;
    }
    public function Save()
    {
        if (!$this->list_id) {
            $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_c336a736" . "f98472e69" . "eb00017dd" . "a5a17e"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_a8391504b805b" . "5d572e9b1a5c5d" . "0169e"]);
            throw new Exception($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_cce0d019091a1" . "93c2ea098ab902" . "d8821"]);
        }
        $this->SaveNewUsers();
        $this->DeleteUnattendedUsers();
        foreach ($this->new_users as $user_id => $_c96f552040dea8086bf8bdd70059542f) {
            $this->users[$user_id] = $_c96f552040dea8086bf8bdd70059542f;
        }
        
        
        $this->users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_39b6f979f725d2d066951" . "011e1554c14"]($this->users, $this->deleted_users);
        
        
    }
    public function GetNewUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return $this->new_users;
    }
    public function GetAllUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->users;
    }
    public function GetOldUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->old_users;
    }
    public function GetDeletedUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->deleted_users;
    }
    protected abstract function SaveNewUsers();
    protected abstract function DeleteUnattendedUsers();
}